var __pointerStore = {};

var imports = function(requirement, callerfile) {
  if (!(this instanceof imports)) {
    return new imports(requirement, _getCallerFile());
  }
  this.requirement = requirement.split('.');
  this.callerfile = callerfile;
  this.lastRequirement = this.requirement[this.requirement.length - 1];
  return this;
}

imports.prototype.as = function(__as) {
  var self = this;
  if(!__pointerStore[__as]) __pointerStore[__as] = {};
  __pointerStore[__as][this.callerfile] = imports.builder.getObjectAtPath(this.requirement);
  var requirement = this.requirement;

   if(!global[__as]) {
     Object.defineProperty(global, __as , {
        get: function() {
            return imports.builder.getObjectAtPath(requirement);
        },
        configurable: true
     });
   }
}

var _getCallerFile = function() {
  try {
      var err = new Error();
      var callerfile;
      var currentfile;

      Error.prepareStackTrace = function (err, stack) { return stack; };

      currentfile = err.stack.shift().getFileName();

      while (err.stack.length) {
          callerfile = err.stack.shift().getFileName();

          if(currentfile !== callerfile) return callerfile;
      }
  } catch (err) {}
  return undefined;
}

var getCallerFile = function() {
  var callerfile;
  try {
      var err = new Error();

      var callerfile;
      var currentfile;

      Error.prepareStackTrace = function (err, stack) { return stack; };

      currentfile = err.stack.shift().getFileName();

      if (err.stack.length) {
        callerfile = err.stack.shift().getFileName();
      }
      while (err.stack &&
              err.stack.length &&
              ( callerfile.indexOf('builder') === -1 ||
                callerfile.indexOf('imports') === -1 ) ) {
          callerfile = err.stack.shift().getFileName();

          if(callerfile.indexOf('builder') === -1
             && callerfile.indexOf('imports') === -1 )
          {
            return callerfile;
          }
      }
  } catch (err) {}
  return callerfile;
}


var namespace = function (_namespace, _callerfile) {
   if (!(this instanceof namespace)) {
     //recurse to create namespace instance
     return new namespace(_namespace, _getCallerFile());
   }
    this._namespace = _namespace;
    this._callerfile = _callerfile;
    namespace.builder.compileNamespaceObject(this);
};

module.exports = {
  imports:        imports,
  namespace:      namespace,
  __pointerStore: __pointerStore,
  getCallerFile:  getCallerFile
}