namespace('Intuition');

imports('Views.View' ).as('View');

var Response = Intuition.extend(function() {

  return {
    init: function(expressResponse, request) {
      this.expressResponse = expressResponse;
      this.request = request;
      this.expressResponse._headers['x-powered-by'] = "Intuition on Express";
      for(var prop in expressResponse) {
        if (typeof expressResponse[prop] != 'function') this[prop] = expressResponse[prop];
      }
    },

    setStatus: function(status) {
      this.expressResponse.status = status;
    },

    send: function(responseObject) {
      if(responseObject instanceof View &&
              responseObject.template &&
              !this.request.isAjax()) {
        this.expressResponse.send(responseObject.renderTemplate());
      } else {
        this.expressResponse.send(responseObject);
      }
      this.expressResponse.end();
    }
  }
});

module.exports = Response;

